# -*- coding: iso-8859-1 -*-
"""
    MoinMoin - event (EventAggregator)

    @copyright: 2012 by Paul Boddie <paul@boddie.org.uk>
    @license: GNU GPL (v2 or later), see COPYING.txt for details.
"""

from EventAggregatorSupport import *

Dependencies = ["pages"]

# Parser support.

class Parser:

    "Interpret and show event information in different ways."

    Dependencies = Dependencies
    extensions = []

    # Output content types preferred by this parser.

    output_mimetypes = ["text/html", "text/calendar"]

    def __init__(self, raw, request, **kw):

        """
        Initialise the parser with the given 'raw' data, 'request' and any
        keyword arguments that may have been supplied.
        """

        self.raw = raw
        self.request = request
        #self.attrs = parseAttributes(kw.get("format_args", ""), False)

    def format(self, fmt):

        "Format an event using the given formatter 'fmt'."

        events = parseEvents(self.raw, self.request.page)

        for event in events:
            formatEvent(event, self.request, fmt)

    # Extra API methods.

    def formatText(self, text, mimetype):

        "Format the event 'text' for the given 'mimetype'."

        events = parseEvents(text)
        formatEventsForOutputType(events, self.request, mimetype)

    # Class methods.

    def getOutputTypes(self):
        return self.output_mimetypes

    getOutputTypes = classmethod(getOutputTypes)

# vim: tabstop=4 expandtab shiftwidth=4
